<script lang="ts">
  import type { ActiveChallenge } from '@models/Challenges';
  import { Alert, Badge, Button, Input, InputGroup, Modal, ModalBody } from '@sveltestrap/sveltestrap';
  import { SubmitFlag } from '@models/Challenges';
  import type { NullableEventRole } from '@auth/models';
  import type { Color } from 'sveltestrap/src/shared';
  import ChallengeFileDownload from '@components/Challenges/ChallengeFileDownload.svelte';
  import { keycloak, team, eventId } from '@stores';
  import { createKanbanTask, KanbanQueryByChallenge, type KanbanTask } from '../../models/Kanban';
  import { getNotificationsContext } from 'svelte-notifications';
  import { getTeammates, type TeamUser } from '../../models/Team';
  import { onMount } from 'svelte';
  import TaskDetailModal from '@components/TaskBoard/TaskDetailModal.svelte';
  import AssignTaskModal from '../TaskBoard/AssignTaskModal.svelte';
  import { Gql } from '@db';
  import UserBadge from '@components/UserBadge.svelte';
  import Markdown from '@components/Markdown/Markdown.svelte';

  const { addNotification } = getNotificationsContext();

  export let challenge: ActiveChallenge;
  export let queryRole: NullableEventRole = null;
  export let open: boolean = false;
  let flag: string;
  let flagInner: HTMLElement;
  let alertMessage: string | null;
  let alertColor: string | null;
  let submissionDisabled: boolean;
  let teammates: TeamUser[] = [];
  let assignTask: (task_id?: string | undefined) => void;
  let showModal: (task_id?: string | undefined) => void;
  let tasks: KanbanTask[] = [];
  let activeTask: KanbanTask | undefined = undefined;
  let kanbanQuerySocket: () => void;
  $: teamId = $team?.id;
  $: activeTask = tasks.find((t) => t.status !== 'Completed');
  $: submissionDisabled = challenge?.solves?.length > 0;

  function updateTaskSubscription(challenge_target: ActiveChallenge) {
    tasks = [];
    if (kanbanQuerySocket) kanbanQuerySocket();
    kanbanQuerySocket = Gql.subscribeSimple(
      `subscription ${KanbanQueryByChallenge(challenge_target.challenge_id)}`,
      (data) => {
        tasks = data.scoreboard_kanban;
      },
    );
  }

  export function show(challengeToShow: ActiveChallenge) {
    challenge = challengeToShow;
    updateTaskSubscription(challengeToShow);
    // reset some values on show
    alertMessage = null;
    flag = '';
    open = true;
  }

  export function hide() {
    open = false;
  }

  export function toggle() {
    if (open) hide();
    else show(challenge);
  }

  async function submitFlag() {
    if (!flag) {
      setAlert('Flag not submitted: No Flag was supplied!', 'warning');
      return;
    }
    if (!$team) {
      setAlert('Flag not submitted: Could not determine your team!', 'danger');
      return;
    }
    let response;
    try {
      response = await SubmitFlag({
        flag,
        team: $team,
        challenge,
        submitter_id: $keycloak?.userId!,
        queryOptions: { queryRole },
      });
    } catch (err) {
      if (err && err[0]?.message) {
        const message = err[0].message;
        if (message.startsWith('Uniqueness violation'))
          setAlert(
            `This flag is incorrect, and has already been submitted. The challenge is not yet solved - keep trying! '${flag}'`,
            'warning',
          );
        else setAlert(`Failed to submit flag '${flag}': ${message}`, 'warning');
        return; // return early
      } else {
        setAlert(
          `Something went wrong submitting flag '${flag}', please sent a screenshot of browser console to staff`,
          'danger',
        );
        throw err;
      }
    }

    if (response?.length > 0) {
      setAlert('Correct!', 'success');
    } else {
      setAlert(`Flag is incorrect: '${flag}'`, 'danger');
    }
  }

  function setAlert(message: string, color: Color) {
    alertMessage = message;
    alertColor = color;
  }

  function onOpen() {
    flagInner.focus();
  }

  onMount(async () => {
    teammates = teamId ? await getTeammates(teamId) : [];
  });

  async function createCtfKanbanTask() {
    await createKanbanTask({
      assignee_id: $keycloak.tokenParsed?.sub,
      created_by: $keycloak.tokenParsed!.sub!,
      title: `[CTF] ${challenge.challenge?.name}`,
      description: `Complete the CTF challenge ${challenge.challenge?.name}`,
      status: 'In Progress',
      team_id: $team?.id || null,
      event_id: $eventId,
      ctf_challenge_id: challenge.challenge?.id,
    });

    addNotification({
      text: `Task Created & Self-Assigned`,
      position: 'bottom-right',
      removeAfter: 3000,
    });
  }
</script>

<AssignTaskModal bind:show={assignTask} {teammates} {tasks} />
<TaskDetailModal bind:show={showModal} {tasks} {teammates} assignTask={(id) => assignTask(id)} />

<Modal on:open={onOpen} isOpen={open} {toggle}>
  <div class="modal-header">
    <h5 class="modal-title w-100">
      <div class="d-flex flex-row justify-content-between">
        <div class="d-flex flex-column m-2">
          {challenge.challenge.name}
          <br />
          <small>
            Designed By: {challenge.challenge.designer}
          </small>
        </div>
        <div class="d-flex flex-column m-2">
          Points: {challenge.points}
          {#if !tasks.length}
            <small class="clickable" on:click={createCtfKanbanTask}>
              <Badge color="success">Create Task</Badge>
            </small>
          {/if}
          {#if tasks.length}
            <small class="clickable" on:click={() => showModal(tasks[0].id)}>
              <Badge color={activeTask ? 'success' : 'primary'}
                >{activeTask ? `View Task` : `View Completed Task`}</Badge
              >
            </small>
          {/if}
        </div>
      </div>
      <div class="d-flex flex-row justify-content-between mx-2">
        <div class="d-flex flex-column">
          {#if activeTask && activeTask.assignee_id && teammates.find((t) => t.id === activeTask?.assignee_id)}
            <small>
              Assigned to:
              <UserBadge
                userId={activeTask.assignee_id}
                firstName={teammates.find((t) => t.id === activeTask?.assignee_id)?.first_name}
                lastName={teammates.find((t) => t.id === activeTask?.assignee_id)?.last_name}
                small
              />
            </small>
          {/if}
        </div>
        <div class="d-flex flex-column">
          {#if activeTask}
            <small
              class="clickable"
              on:click={() => {
                assignTask(activeTask.id);
              }}
            >
              <Badge color="primary">Reassign</Badge>
            </small>
          {/if}
        </div>
      </div>
    </h5>
  </div>
  <ModalBody>
    <Markdown source={challenge.challenge.description} />
    {#if challenge.files.length > 0}
      {#each challenge.files as file}
        <ChallengeFileDownload {file} />
      {/each}
    {/if}
  </ModalBody>
  <div class="d-flex flex-column m-3">
    <div class="d-flex flex-row justify-content-end">
      <InputGroup>
        <Input
          on:keyup={(e) => {
            if (e.code === 'Enter' || e.code === 'NumpadEnter') submitFlag();
          }}
          bind:inner={flagInner}
          bind:value={flag}
          bind:disabled={submissionDisabled}
          placeholder={submissionDisabled ? 'Challenge Solved!' : 'c2ctf{flag}'}
        />
        <Button disabled={submissionDisabled} on:click={submitFlag} color="primary">Submit Flag</Button>
      </InputGroup>
    </div>
    <div class="alertDiv mt-3">
      <Alert color={alertColor} isOpen={!!alertMessage} fade={true}>
        {alertMessage}
      </Alert>
    </div>
  </div>
</Modal>
